//___________________________________________________________________
//
//                         Class AboutDlg
//
//                           Definitions
//___________________________________________________________________

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/dialog.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/sizer.h>
#include "AboutDlg.h"

#include "Main.h"
#include "File.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

BEGIN_EVENT_TABLE(AboutDlg, wxDialog)
	EVT_TEXT_URL	(-1, AboutDlg::OnURLClick	)
END_EVENT_TABLE()

AboutDlg::AboutDlg():
wxDialog(NULL, -1, "About aUCBLogo-4.692", wxPoint(-1,-1), 
			wxSize(640,640), wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER, 
			"AboutDialog")
{
	t=new wxTextCtrl(this, -1, 
		wxEmptyString, wxDefaultPosition, wxDefaultSize,
		wxTE_MULTILINE | wxTE_READONLY | wxTE_RICH2 | 
		wxTE_AUTO_URL |wxTE_CENTRE);
	*t << "\n";
	wxTextAttr ota=t->GetDefaultStyle(), ta=ota;
	wxFont f=ta.GetFont();
	f.SetPointSize(20);
	f.SetFaceName("Times");
	f.SetWeight(wxBOLD);
	ta.SetFont(f);
	t->SetDefaultStyle(ta);
	*t	<< "aUCBLogo-4.692\n";
	t->SetDefaultStyle(ota);
	*t	<< "\n"
		<< "Developed by Andreas Micheler.\n"
		<< "http://www.physik.uni-augsburg.de/~micheler/\n"
		<< "(Andreas.Micheler@Physik.Uni-Augsburg.de)\n"
		<< "\n"
		<< "Based on UCBLogo 4.6 (Berkeley Logo)\n"
		<< "written by Brian Harvey\n"
		<< "http://www.cs.berkeley.edu/~bh/\n"
		<< "(bh@cs.berkeley.edu)\n"
		<< "with contributions from his students "
		<< "Daniel van Blerkom, Khang Dao, Michael Katz, "
		<< "Douglas Orleans, and Sanford Owings.\n"
		<< "\n"
		<< "aUCBLogo is free software and shall not be sold. "
		<< "Full source code is included, so it's OpenSource "
		<< "and may be further developed by anyone interested.\n"
		<< "\n"
		<< "License is the GNU General Public License.\n"
		<< "\n"
		<< "Internet News Group: comp.lang.logo\n"
		<< "Or visit the LogoForum: http://groups.yahoo.com/group/LogoForum\n"
		<< "\n"
		<< "Many features have only been possible to include "
		<< "by using the following free libraries:\n"
		<< "\n"
		<< "wxWidgets-2.6.1 (formerly wxWindows): http://www.wxwidgets.org/ "
		<< "News group: comp.soft-sys.wxwindows\n"
		<< "\n"
		<< "freetype-2.1.9: http://www.freetype.org/\n"
		<< "\n"
		<< "FTGL-2.1.1: http://homepages.paradise.net.nz/henryj/code/\n"
		<< "\n"
		<< "GL2PS-1.2.7: http://www.geuz.org/gl2ps/\n"
		<< "\n"
		<< "MAPM-4.9.2: http://www.tc.umn.edu/~ringx004/mapm-main.html\n";
	wxButton *b=new wxButton(this, wxID_OK, wxEmptyString, 
		wxDefaultPosition, wxSize(100,30));
	wxBoxSizer *bs=new wxBoxSizer(wxVERTICAL);
	bs->Add(t, 1000, wxEXPAND | wxTOP|wxLEFT|wxRIGHT, 10);
	bs->Add(100, 30, 30, wxEXPAND);
	bs->Add(b, 80, wxSHAPED | wxALIGN_CENTER_HORIZONTAL, 0);
	bs->Add(100, 30, 30, wxEXPAND);
	SetSizer(bs);
	t->SetInsertionPoint(0);
	b->SetFocus();
}

void AboutDlg::OnURLClick(wxTextUrlEvent &ev)
{
	wxMouseEvent me=ev.GetMouseEvent();
	if (me.IsButton())
	{	int s=ev.GetURLStart(), e=ev.GetURLEnd();
		wxString url=t->GetRange(s, e);
		wxLaunchDefaultBrowser(url);
	}
}
