#ifndef Node_included
	#include "Node.h"
#endif

class Array: public Node	// is an array with a length and an origin.
{
	int _length, _origin;
	NodePP _data;

	public:
		static const Array aArray;

		operator_new;
		Array(): Node(ARRAY), _length(0), _origin(0), _data(0) {}
		Array(int length_, int origin_=1);
		Array(ArrayP array_);
		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();

		void setPtrs();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string();

		OPERATORS_DECL
		int compare(NodeP nd);
		int count();
		int _sizeof();
		StringP _typeof();
		bool equalP(NodeP b);
		NodeP deepCopy();
		NodeP first_();
		NodeP butFirst();
		NodeP firsts();
		NodeP butFirsts();
		NodeP last();
		NodeP butLast();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP resize(int newsize);
		NodeP item(int index);
		NodeP item(NodeP index, NodeP result);
		NodeP items(NodeP start, NodeP end);
		NodeP mdItem(NodeP index);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP setitems(NodeP start, NodeP newitems);
		NodeP memberP(NodeP subobj, bool notp, bool substr);
		NodeP reverse();
		NodeP rotate(int places);
		NodeP shuffle();
		NodeP upper();
		NodeP lower();
		PairP list();
		ArrayP array(int origin=1);
		IntArrayP intarray(int origin=1);
		Int16ArrayP int16array(int origin=1);
		FloatArrayP floatarray(int origin=1);
		GRAPHIC_DECL

		 int length() {return _length;}
		 int origin() {return _origin;}
		NodePP data() {return _data;}
		void setorigin(int origin_) {_origin=origin_;}

		static bool circular(NodeP _nd1, NodeP _nd2);
};

#define Array_included
