//___________________________________________________________________
//
//                         Button Header
//___________________________________________________________________


extern Function 
	lButton, lButtonDestroy, lButtonOnClick, lButtonEnable;

class Button: public wxButton
{
	public:
		PairP onClick;
		ButtonNodeP buttonNode;

		Button(ButtonNodeP buttonNode_);
		Button(ButtonNodeP buttonNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label,
			PairP onClick_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "Button");
		~Button();

		void 
			OnClose(wxCloseEvent &event),
			OnClick(wxCommandEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef Button *ButtonP;

class ButtonNode: public Node
{
	public:
		ButtonP button;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;

		static const ButtonNode aButtonNode;

		operator_new;
		PairP onClick();
		void setonClick(NodeP function);

		ButtonNode();
		ButtonNode(
			FrameNodeP parentFrame_, 
			GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
