#ifndef Node_included
	#include "Node.h"
#endif

#include <complex>

typedef std::complex<double> complexd;	
typedef complexd* complexdP;

class Complexd: public Node 
{
	public: 
		complexd complex_;

		static const int digits;
		static const Complexd aComplexd;

		operator_new;
		Complexd():         Node(COMPLEX), complex_(0) {}
		Complexd(complexd c): Node(COMPLEX), complex_(c) {}
		Complexd(double re): Node(COMPLEX), complex_(re) {}
		Complexd(double re, double im): Node(COMPLEX), complex_(re,im) {}

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP   string();
		   int   numberP() {return 1;}
			double getnumber() 
			{	return ::sqrt(Float::sqr(complex_.real())+Float::sqr(complex_.imag()));}
		 NodeP    number() {return this;}

		OPERATORS_DECL
		int compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d), _max(double d);
		NodeP Norm(), maxNorm(), 
			item(NodeP index, NodeP result),
			bititem(NodeP index),
			memberP(NodeP subobj, bool notp, bool substr),
			readbin(FileP file);
		PairP list();

		static void init(), reset_FPU();
		static double abs(complexd x);
		static complexd 
			rnd(), 
			sqr(complexd x),
			Remainder(complexd x, double d), 
			Remainder(double x, complexd d), 
			Remainder(complexd x, complexd d), 

			      mod(complexd x, double d),
			      mod(double x, complexd d),
			      mod(complexd x, complexd d);
};

#define Complex_included
