//////////////////////////////////////////////////////////////////////////////
// File:        prefs.cpp
// Purpose:     STC test Preferences initialization
// Maintainer:  Wyo
// Created:     2003-09-01
// RCS-ID:      $Id: prefs.cpp,v 1.3 2004/05/25 11:14:03 JS Exp $
// Copyright:   (c) wxGuide
// Licence:     wxWindows licence
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// headers
//----------------------------------------------------------------------------

//! application headers
#include "EdDefsExt.h"     // Additional definitions
#include "EdPrefs.h"       // Preferences

//============================================================================
// declarations
//============================================================================

//----------------------------------------------------------------------------
//! language types
const CommonInfo g_CommonPrefs = {
    // editor functionality prefs
    true,  // syntaxEnable
    true,  // foldEnable
    true,  // indentEnable
    // display defaults prefs
    false, // overTypeInitial
    false, // readOnlyInitial
    false,  // wrapModeInitial
    false, // displayEOLEnable
    false, // IndentGuideEnable
    false, // lineNumberEnable
    false, // longLineOnEnable
    false, // whiteSpaceEnable
};

//----------------------------------------------------------------------------
// keywordlists


// aUCBLogo

wxChar *aUCBLogoWordlist1 =
	_T("_defMacro _Macro apply break case catch continue continueLoop define do_until ")
	_T("do_while doubleBuffer end false for foreach forever goTo ")
	_T("GraphicEnd GraphicStart identityMatrix IDM if ifElse ifF ")
	_T("ifFalse ifT ifTrue ignore make Matrix output pause PolyEnd ")
	_T("PolyStart redraw repeat repCount repeatCount run runParse ")
	_T("runResult setIdentityMatrix setIDM setMatrix setTurtleMatrix ")
	_T("Shell ShellSpawn singleBuffer step stop SurfaceColumn SurfaceEnd ")
	_T("SurfaceStart test Tag TessContour TessEnd TessStart Thing throw ")
	_T("TurtleMatrix to trace true unstep until untrace ")
	_T("VideoEnd VideoFrame VideoStart wait while ");

wxChar *aUCBLogoWordlist2 =
	_T("_eq _maybeOutput _setBF _setButFirst _setFirst _setItem _setPos ")
	_T("abs addColors addColorsMod ")
	_T("allFullScreen allOpen AlNumP AlNum? AlphaP Alpha? ")
	_T("and and2 Arc ArcCos ArcSin ArcTan Arity ")
	_T("Array ArrayP Array? ASCII ASCIIP ASCII? aShift ")
	_T("back Background backslashedP backslashed? BackslashEncode ")
	_T("beforeP before? beginBusyCursor BigFloat BigFloatSetPrecision ")
	_T("BitAnd BitCopy BitItem BitMakeTransparent BitMaxX BitMaxY BitNot ")
	_T("BitOr BitPaste BitPixel BitSetPixel BitXOr boldTextMode ") 
	_T("BoxSizer BoxSizerAdd BoxSizerDestroy ")
	_T("buried bury BusyCursorP BusyCursor? butFirst butFirsts butLast ")
	_T("Button ButtonDestroy ButtonEnable ButtonOnClick ")
	_T("bye Calls CaseIgnoredP CaseIgnored? castShadows changeDir ")
	_T("Char CharP Char? CharUnderCursor ")
	_T("CheckBox CheckBoxDestroy CheckBoxEnable ")
	_T("CheckBoxOnClick CheckBoxSet CheckBoxValue ")
	_T("ChoiceBox ChoiceBoxAppend ChoiceBoxCount ")
	_T("ChoiceBoxDestroy ChoiceBoxEnable ")
	_T("ChoiceBoxOnChar ChoiceBoxOnKeyDown ChoiceBoxOnKeyUp ChoiceBoxOnSelect ")
	_T("ChoiceBoxRemoveItem ")
	_T("ChoiceBoxSelection ChoiceBoxSetBackgroundColor ")
	_T("ChoiceBoxSetChoices ChoiceBoxSetColor ")
	_T("ChoiceBoxSetFontName ChoiceBoxSetFontSize ")
	_T("ChoiceBoxSetFontStyle ChoiceBoxSetFontWeight ")
	_T("ChoiceBoxSetItem ")
	_T("ChoiceBoxSetSelection ")
	_T("circle circularP circular? clean clearPortBit clearScreen clearShadows ")
	_T("clearText close CntrlP Cntrl? combine ")
	_T("ComboBox ComboBoxAppend ComboBoxCount ComboBoxDestroy ComboBoxEnable ")
	_T("ComboBoxOnChange ComboBoxOnChar ComboBoxOnEnter ")
	_T("ComboBoxOnKeyDown ComboBoxOnKeyUp ComboBoxOnSelect ")
	_T("ComboBoxRemoveItem ComboBoxSelection ")
	_T("ComboBoxSetBackgroundColor ComboBoxSetChoices ComboBoxSetColor ")
	_T("ComboBoxSetFontName ComboBoxSetFontSize ")
	_T("ComboBoxSetFontStyle ComboBoxSetFontWeight ")
	_T("ComboBoxSetItem ComboBoxSetSelection ComboBoxSetValue ComboBoxValue ")
	_T("Comment complexP complex? ")
	_T("conjugate ConsoleSetFocus Contents copyDef ")
	_T("Cos count cross CSymP CSym? Cursor ")
	_T("deepCopy deleteTextures dequeue ")
	_T("Difference DigitP Digit? DirectoryP Directory? ")
	_T("DirSelector disableCylinderLines ")
	_T("disableDepthTest disableDither disableFog disableLineSmooth ")
	_T("disableLighting disablePolySmooth ")
	_T("disablePointSmooth disableRoundLineEnds disableShadows ")
	_T("disableTextMouseEvents disableTexture dispatchMessages ")
	_T("Distance DistanceXYZ DLCall drawGraphic dribble ")
	_T("DynamicLibrary DynamicLibraryCall ")
	_T("edit editFile Ellipse EllipseArc Ellipsoid emptyP empty? ")
	_T("enableCylinderLines enableDepthTest ")
	_T("enableDither enableFog enableLineSmooth enableLighting ")
	_T("enablePointSmooth enablePolySmooth enableRoundLineEnds enableShadows ")
	_T("enableTextMouseEvents enableTexture endBusyCursor ")
	_T("EofP Eof? epsPict equalP equal? erAll ")
	_T("erase eraseAll eraseFile eraseNames eraseProcedures ")
	_T("error exp Faculty factorize Fence ")
	_T("FileP File? Files FileSelector FileSize FileTime fill ")
	_T("fillCircle fillEllipse fillPie fillRect first firsts ")
	_T("FloatArray FloatArrayP FloatArray? ")
	_T("FloatControl FloatControlDestroy FloatControlEnable ")
	_T("FloatControlOnChange ")
	_T("FloatControlSetRange FloatControlSetValue FloatControlValue ")
	_T("floatP float? FloodColor ")
	_T("Form forward fPut ")
	_T("Frame FrameDestroy FrameEnable ")
	_T("FrameFullScreen FrameIconize FrameMaximize ")
	_T("FrameOnChar FrameOnKeyDown FrameOnKeyUp ")
	_T("FrameSetBackgroundColor FrameSetClientSize FrameSetColor FrameSetFocus ")
	_T("FrameSetFontName FrameSetFontSize FrameSetFontStyle FrameSetFontWeight ")
	_T("FrameSetShape FrameSetSizer ")
	_T("fullScreen fullText ")
	_T("Gauge GaugeDestroy GaugeSetBackgroundColor ")
	_T("GaugeSetColor GaugeSetRange GaugeSetValue GaugeValue ")
	_T("gcd genSym getColorDatabase ")
	_T("getColorFromUser getFontFromUser getMultipleChoices getNumberFromUser ")
	_T("getPasswordFromUser getSingleChoice getSingleChoiceIndex ")
	_T("getTextFromUser getPortBit getWorkingDirectory ")
	_T("gProp ")
	_T("Graph GraphCurrent GraphDestroy ")
	_T("GraphOnChar GraphOnKeyDown GraphOnKeyUp ")
	_T("GraphOnMouseLeftDClick GraphOnMouseLeftDown GraphOnMouseLeftUp ")
	_T("GraphOnMouseMiddleDClick GraphOnMouseMiddleDown GraphOnMouseMiddleUp ")
	_T("GraphOnMouseMotion ")
	_T("GraphOnMouseRightDClick GraphOnMouseRightDown GraphOnMouseRightUp ")
	_T("GraphP Graph? GraphSetCurrent ")
	_T("greater greaterEqual ")
	_T("greaterEqualP greaterEqual? greaterP greater? Heading ")
	_T("help hideTurtle Home HSB HSBA IdentityMatrix imag insertMode ")
	_T("Int Int8 Int8P Int8? Int16 Int16P Int16? ")
	_T("IntControl IntControlDestroy IntControlEnable IntControlOnChange ")
	_T("IntControlSetRange IntControlSetValue IntControlValue ")
	_T("intForm IntP Int? IntArray IntArrayP IntArray? ")
	_T("Int16Array Int16ArrayP Int16Array? ")
	_T("invertMatrix iSeq Item Items Key KeyboardValue ")
	_T("KeyP Key? Label LabelAlign LabelFont LabelSize LabelWeight last ")
	_T("left leftPortShift leftRoll ")
	_T("less lessEqual lessEqualP lessEqual? lessP less? ")
	_T("List ")
	_T("ListBox ListBoxAppend ListBoxCount ListBoxDestroy ListBoxEnable ")
	_T("ListBoxOnChar ListBoxOnDClick ListBoxOnKeyDown ListBoxOnKeyUp ")
	_T("ListBoxOnSelect ListBoxRemoveItem ListBoxSelections ")
	_T("ListBoxSetBackgroundColor ListBoxSetChoices ListBoxSetColor ")
	_T("ListBoxSetFontName ListBoxSetFontSize ")
	_T("ListBoxSetFontStyle ListBoxSetFontWeight ")
	_T("ListBoxSetItem ListBoxSetSelections ")
	_T("ListControl ListControlColumn ListControlColumnCount ")
	_T("ListControlDeleteItem ListControlDestroy ListControlEnable ")
	_T("ListControlGet ListControlGetColumn ListControlGetItem ")
	_T("ListControlGetRow ListControlInsertColumn ")
	_T("ListControlInsertItem ListControlItemCount ")
	_T("ListControlOnChar ListControlOnColClick ")
	_T("ListControlOnColEndDrag ListControlOnItemActivated ")
	_T("ListControlOnItemSelected ListControlOnKeyDown ListControlOnKeyUp ")
	_T("ListControlRow ListControlSet ListControlSetBackgroundColor ")
	_T("ListControlSetColor ListControlSetColumn ")
	_T("ListControlSetFontName ListControlSetFontSize ")
	_T("ListControlSetFontStyle ListControlSetFontWeight ")
	_T("ListControlSetItem ListControlSetRow ListControlSort ListControlText ")
	_T("ListP List? LN load ")
	_T("loadImage loadPicture loadPictureText ")
	_T("local Log10 ")
	_T("LogoComspec LogoEditor LogoHelpDir LogoInstance ")
	_T("LogoLibDir LogoTempDir LogoVersion ")
	_T("lowerCase LowerP Lower? lowPassFilter lPut lShift ")
	_T("MacroP Macro? makeDirectory MandelIterate max maxNorm ")
	_T("mdItem mdSetItem ")
	_T("Member MemberP Member? merge mergePairs mergeSort MessageBox ")
	_T("MidiAllSoundsOff MidiClose MidiCountDevices MidiDeviceInfo ")
	_T("MidiMessage MidiNoteOn MidiNoteOff MidiOpen ")
	_T("MidiOutStream MidiOutStreamsFinished MidiOutStreamsStart ")
	_T("MidiOutStreamsStop MidiProgramChange ")
	_T("min Minus MIPS ")
	_T("Mod Modulo MouseButtons MousePos MouseX MouseY movePixel moveLine ")
	_T("NameInTableP NameInTable? NameP Name? Names newTurtle ")
	_T("Nodes noDribble noRefresh Norm not ")
	_T("notPortBit notFullScreen NumberP Number? ")
	_T("OnChar OnKeyDown OnKeyUp ")
	_T("OnMouseLeftDClick OnMouseLeftDown OnMouseLeftUp ")
	_T("OnMouseMiddleDClick OnMouseMiddleDown OnMouseMiddleUp ")
	_T("OnMouseMotion ")
	_T("OnMouseRightDClick OnMouseRightDown OnMouseRightUp ")
	_T("OnTextMouseLeftDClick OnTextMouseLeftDown OnTextMouseLeftUp ")
	_T("OnTextMouseMiddleDClick OnTextMouseMiddleDown OnTextMouseMiddleUp ")
	_T("OnTextMouseMotion ")
	_T("OnTextMouseRightDClick OnTextMouseRightDown OnTextMouseRightUp ")
	_T("openAppend openRead openReadBin openUpdate openUpdateBin openWrite ")
	_T("openWriteBin or or2 Orientation OSScreenSize overwriteMode Palette ")
	_T("partialEllipsoid ")
	_T("PenColor PenDown PenDownP PenDown? PenErase PenMode PenPaint ")
	_T("PenReverse PenSize PenUp perspective pick Pitch Pixel ")
	_T("plainTextMode playWave playWaveFast PList PLists ")
	_T("PortIn PortOut pop popMatrix Pos ")
	_T("PosXYZ Power pProp primeP prime? ")
	_T("Primitive? PrimitiveP Primitives print printOut printOutTitles ")
	_T("PrintP Print? ProcedureP Procedure? Procedures ")
	_T("Product PropertyList PropertyLists PunctP Punct? push pushMatrix ")
	_T("queue Quotient radArcCos radArcSin radArcTan radCos ")
	_T("RadioButton RadioButtonDestroy RadioButtonEnable RadioButtonOnClick ")
	_T("RadioButtonSet RadioButtonValue ")
	_T("radTan random rawASCII readChar readCharExt ")
	_T("readComplexBin Reader ReaderPos readFloatArray readFloatArrayBin ")
	_T("readFloatBin readIntBin readIntArrayBin ")
	_T("readInt16Bin readInt16ArrayBin ")
	_T("readInt8Bin readStructBin readUInt8Bin ")
	_T("readWord real refresh reHSB reHSBA Remainder remDup remove removeItem ")
	_T("remProp replace reRandom reRGB reRGBA resize reverse rightPortShift ")
	_T("rightRoll rnd RGB RGBA right Roll rotate round ")
	_T("rSeq rSeqFloatArray saturateAbove saturateBelow save saveImage ")
	_T("savePicture savePictureText ")
	_T("savePostScript savePS saveScreen saveScreenVector saveSize ")
	_T("ScreenColor scroll scrollCal scrollCalibrate Scrunch ")
	_T("Se Sentence ")
	_T("setCallsSplitter setCaseIgnored setCursor setCylinderPos ")
	_T("setDepthFunc setEye setFloodColor ")
	_T("setFogColor setFogDensity setFogMode setFogRange ")
	_T("setHeading setItem setItems ")
	_T("setLabelAlign setLabelFont setLabelSize setLabelWeight ")
	_T("setLightAmbient setLightDiffuse ")
	_T("setLightSpecular setLightPos ")
	_T("setLogoComspec setLogoEditor setLogoHelpDir ")
	_T("setLogoLibDir setLogoTempDir ")
	_T("setMargins ")
	_T("setMaterialAmbient setMaterialDiffuse setMaterialSpecular ")
	_T("setMaterialEmission setMaterialShininess setOrientation setPalette ")
	_T("setPenColor setPenPattern setPenSize setPitch ")
	_T("setPixel setPixelXY setPixelXYZ setPos setPosXYZ setPortBit ")
	_T("setPrintPrecision setReader setReaderPos setRoll setSaveSize ")
	_T("setScreenColor setScreenRange setScrunch setShadowColor setSpherePos ")
	_T("setTessWindingRule setTexPos ")
	_T("setTextColor setTextFont setTextSize setTextSelection setTexXY setTexPos ")
	_T("setTurtle setUpdateGraph setVarsSplitter setWriter setWriterPos ")
	_T("setXY setXYZ setX setY setZ ShadowColor show shownP shown? ")
	_T("showTurtle shrinkStacks shuffle Signum Sin SizeOf ")
	_T("Slider SliderDestroy SliderEnable SliderOnScroll ")
	_T("SliderSetRange SliderSetValue SliderValue ")
	_T("Sound Sounds SoundsFinished SoundsStop SpaceP Space? Sphere ")
	_T("spinX spinY spinZ ")
	_T("splitScreen Sqr Sqrt standout ")
	_T("StaticText StaticTextDestroy StaticTextLabel ")
	_T("StaticTextSetBackgroundColor StaticTextSetColor ")
	_T("StaticTextSetFontName StaticTextSetFontSize ")
	_T("StaticTextSetFontStyle StaticTextSetFontWeight StaticTextSetLabel ")
	_T("StringBuffer StringBufferToWord ")
	_T("Struct subStringP subString? Sum Table Text ")
	_T("TextControl TextControlAppend TextControlCursor ")
	_T("TextControlDestroy TextControlEnable ")
	_T("TextControlInsertMode TextControlOnChange TextControlOnChar ")
	_T("TextControlOnEnter TextControlOnKeyDown TextControlOnKeyUp ")
	_T("TextControlOverwriteMode TextControlSetBackgroundColor ")
	_T("TextControlSetColor TextControlSetCursor ")
	_T("TextControlSetFontName TextControlSetFontSize ")
	_T("TextControlSetFontStyle TextControlSetFontWeight ")
	_T("TextControlSetInsertionPointEnd TextControlSetValue ")
	_T("TextControlValue TextControlWrite ")
	_T("TextMousePos TextMouseX TextMouseY TextScreen Texture ")
	_T("Time TimeFine TimeMilli TimerFreq TimeURes ")
	_T("ToggleButton ToggleButtonDestroy ToggleButtonEnable ToggleButtonOnClick ")
	_T("ToggleButtonSetValue ToggleButtonValue ")
	_T("toList toListList ")
	_T("Tone Tones TonesFinished TonesStop ")
	_T("towards towardsXYZ traced trunc ")
	_T("Turtle type typeBin TypeOf ")
	_T("UInt8 UInt8P UInt8? unbury unperspective updateCalls updateGraph ")
	_T("updateVars upperCase UpperP Upper? upPitch ")
	_T("waitMS waituS Window Word WordP Word? WordUnderCursor ")
	_T("WriterPos Writer xAdd xCopy xCor xDigitP ")
	_T("xDigit? xDiv xMod xMul xSub yCor zCor ");

wxChar *aUCBLogoWordlist3 =
	_T("` arc2 axes buryall buryname ")
	_T("cascade cascade2 check closeall cngon cond ")
	_T("crbox crossmap dir dirlg displaymatrix e edall edn edns edpl edpls ")
	_T("edps emacs_debug ern erns erpl filep filter find float2ratio h hex ")
	_T("invoke isprime lcm loadpalette localmake macroexpand map map_se ")
	_T("mdarray name namelist pen pllist poall pon pons popl ")
	_T("popls pops pots profile qrest quoted radd ratio ratio2float rdiv reduce ")
	_T("reset rmul rotatescene rsub savel setpen smul stepall traceall ")
	_T("transfer transpose transposematrix unburyall unburyname vowelp ");

wxChar *aUCBLogoWordlist4 =
	_T("bk bFs bF BitTrans bL cd cS cT co disCL disLS disPS disRLE ")
	_T("disTex down ed enCL enLS enPS enRLE enTex er erF erNS erPLs ")
	_T("erPs fd fS GC hT loadPic ")
	_T("lr lt op PC PD PE pO poT PPt PX PU pr ")
	_T("rC rCE rCs rL rSeqFA rW rr rt savePic SC Se setFC ")
	_T("setH setM setPC setPS setSC setTC setTM sT sS TM TS uP ");

wxChar *aUCBLogoWordlist5 =
	_T("erract IntMax Int16Max ")
	_T("loadNoisily printDepthLimit printWidthLimit ")
	_T("reDefP Startup UInt8Max ");

wxString aUCBLogoWordlist=wxString(aUCBLogoWordlist1)
								+ wxString(aUCBLogoWordlist2)
								+ wxString(aUCBLogoWordlist3)
								+ wxString(aUCBLogoWordlist4)
								+ wxString(aUCBLogoWordlist5);

wxString
	aUCBLogoWordlistLow1=wxString(aUCBLogoWordlist1).Lower(),
	aUCBLogoWordlistLow2=wxString(aUCBLogoWordlist2).Lower(),
	aUCBLogoWordlistLow3=wxString(aUCBLogoWordlist3).Lower(),
	aUCBLogoWordlistLow4=wxString(aUCBLogoWordlist4).Lower(),
	aUCBLogoWordlistLow5=wxString(aUCBLogoWordlist5).Lower(),

	aUCBLogoWordlistBoth1=aUCBLogoWordlistLow1+aUCBLogoWordlist1,
	aUCBLogoWordlistBoth2=aUCBLogoWordlistLow2+aUCBLogoWordlist2,
	aUCBLogoWordlistBoth3=aUCBLogoWordlistLow3+aUCBLogoWordlist3,
	aUCBLogoWordlistBoth4=aUCBLogoWordlistLow4+aUCBLogoWordlist4,
	aUCBLogoWordlistBoth5=aUCBLogoWordlistLow5+aUCBLogoWordlist5;


// C++

wxChar* CppWordlist1 =
    _T("asm auto bool break case catch char class const const_cast \
       continue default delete do double dynamic_cast else enum explicit \
       export extern false float for friend goto if inline int long \
       mutable namespace new operator private protected public register \
       reinterpret_cast return short signed sizeof static static_cast \
       struct switch template this throw true try typedef typeid \
       typename union unsigned using virtual void volatile wchar_t \
       while");
wxChar* CppWordlist2 =
    _T("file");
wxChar* CppWordlist3 =
    _T("a addindex addtogroup anchor arg attention author b brief bug c \
       class code date def defgroup deprecated dontinclude e em endcode \
       endhtmlonly endif endlatexonly endlink endverbatim enum example \
       exception f$ f[ f] file fn hideinitializer htmlinclude \
       htmlonly if image include ingroup internal invariant interface \
       latexonly li line link mainpage name namespace nosubgrouping note \
       overload p page par param post pre ref relates remarks return \
       retval sa section see showinitializer since skip skipline struct \
       subsection test throw todo typedef union until var verbatim \
       verbinclude version warning weakgroup $ @ "" & < > # { }");


// Python

wxChar* PythonWordlist1 =
    _T("and assert break class continue def del elif else except exec \
       finally for from global if import in is lambda None not or pass \
       print raise return try while yield");
wxChar* PythonWordlist2 =
    _T("ACCELERATORS ALT AUTO3STATE AUTOCHECKBOX AUTORADIOBUTTON BEGIN \
       BITMAP BLOCK BUTTON CAPTION CHARACTERISTICS CHECKBOX CLASS \
       COMBOBOX CONTROL CTEXT CURSOR DEFPUSHBUTTON DIALOG DIALOGEX \
       DISCARDABLE EDITTEXT END EXSTYLE FONT GROUPBOX ICON LANGUAGE \
       LISTBOX LTEXT MENU MENUEX MENUITEM MESSAGETABLE POPUP PUSHBUTTON \
       RADIOBUTTON RCDATA RTEXT SCROLLBAR SEPARATOR SHIFT STATE3 \
       STRINGTABLE STYLE TEXTINCLUDE VALUE VERSION VERSIONINFO VIRTKEY");


//----------------------------------------------------------------------------
//! languages
const LanguageInfo g_LanguagePrefs [] = {
    // aUCBLogo case insensitive
    {_T("aUCBLogo case insensitive"),
     _T("*.lg;*."),
     wxSTC_LEX_AUCBLOGONOCASE,
     {{mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_COMMENT, NULL},
      {mySTC_TYPE_COMMENT_LINE, NULL},
      {mySTC_TYPE_COMMENT_DOC, NULL},
      {mySTC_TYPE_NUMBER, NULL},
      {mySTC_TYPE_WORD1, aUCBLogoWordlistLow1}, // KEYWORDS
      {mySTC_TYPE_WORD2, aUCBLogoWordlistLow2},
      {mySTC_TYPE_WORD3, aUCBLogoWordlistLow3},
      {mySTC_TYPE_WORD4, aUCBLogoWordlistLow4},
      {mySTC_TYPE_WORD5, aUCBLogoWordlistLow5},
      {mySTC_TYPE_WORD6, NULL},
      {mySTC_TYPE_STRING, NULL},
      {mySTC_TYPE_CHARACTER, NULL},
      {mySTC_TYPE_UUID, NULL},
      {mySTC_TYPE_PREPROCESSOR, NULL},
      {mySTC_TYPE_OPERATOR, NULL},
      {mySTC_TYPE_IDENTIFIER, NULL},
      {mySTC_TYPE_STRING_EOL, NULL},
      {mySTC_TYPE_DEFAULT, NULL}, // VERBATIM
      {mySTC_TYPE_REGEX, NULL},
      {mySTC_TYPE_COMMENT_SPECIAL, NULL}, // DOXY
      {mySTC_TYPE_ERROR, NULL}, // KEYWORDS ERROR
      {-1, NULL},
      {-1, NULL},
      {24, "to"},
      {25, "end"},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL}},
     mySTC_FOLD_COMMENT | mySTC_FOLD_COMPACT | mySTC_FOLD_PREPROC},
    // aUCBLogo case sensitive
    {_T("aUCBLogo case sensitive"),
     _T("*.lg;*."),
     wxSTC_LEX_AUCBLOGO,
     {{mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_COMMENT, NULL},
      {mySTC_TYPE_COMMENT_LINE, NULL},
      {mySTC_TYPE_COMMENT_DOC, NULL},
      {mySTC_TYPE_NUMBER, NULL},
      {mySTC_TYPE_WORD1, aUCBLogoWordlistBoth1}, // KEYWORDS
		{mySTC_TYPE_WORD2, aUCBLogoWordlistBoth2},
      {mySTC_TYPE_WORD3, aUCBLogoWordlistBoth3},
      {mySTC_TYPE_WORD4, aUCBLogoWordlistBoth4},
		{mySTC_TYPE_WORD5, aUCBLogoWordlistBoth5},
      {mySTC_TYPE_WORD6, NULL},
      {mySTC_TYPE_STRING, NULL},
      {mySTC_TYPE_CHARACTER, NULL},
      {mySTC_TYPE_UUID, NULL},
      {mySTC_TYPE_PREPROCESSOR, NULL},
      {mySTC_TYPE_OPERATOR, NULL},
      {mySTC_TYPE_IDENTIFIER, NULL},
      {mySTC_TYPE_STRING_EOL, NULL},
      {mySTC_TYPE_DEFAULT, NULL}, // VERBATIM
      {mySTC_TYPE_REGEX, NULL},
      {mySTC_TYPE_COMMENT_SPECIAL, NULL}, // DOXY
      {mySTC_TYPE_ERROR, NULL}, // KEYWORDS ERROR
      {-1, NULL},
      {-1, NULL},
      {24, "to"},
      {25, "end"},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL}},
     mySTC_FOLD_COMMENT | mySTC_FOLD_COMPACT | mySTC_FOLD_PREPROC},
    // C++
    {_T("C++"),
     _T("*.c;*.cc;*.cpp;*.cxx;*.cs;*.h;*.hh;*.hpp;*.hxx;*.sma"),
     wxSTC_LEX_CPP,
     {{mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_COMMENT, NULL},
      {mySTC_TYPE_COMMENT_LINE, NULL},
      {mySTC_TYPE_COMMENT_DOC, NULL},
      {mySTC_TYPE_NUMBER, NULL},
      {mySTC_TYPE_WORD1, CppWordlist1}, // KEYWORDS
      {mySTC_TYPE_STRING, NULL},
      {mySTC_TYPE_CHARACTER, NULL},
      {mySTC_TYPE_UUID, NULL},
      {mySTC_TYPE_PREPROCESSOR, NULL},
      {mySTC_TYPE_OPERATOR, NULL},
      {mySTC_TYPE_IDENTIFIER, NULL},
      {mySTC_TYPE_STRING_EOL, NULL},
      {mySTC_TYPE_DEFAULT, NULL}, // VERBATIM
      {mySTC_TYPE_REGEX, NULL},
      {mySTC_TYPE_COMMENT_SPECIAL, NULL}, // DOXY
      {mySTC_TYPE_WORD2, CppWordlist2}, // EXTRA WORDS
      {mySTC_TYPE_WORD3, CppWordlist3}, // DOXY KEYWORDS
      {mySTC_TYPE_ERROR, NULL}, // KEYWORDS ERROR
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL}},
     mySTC_FOLD_COMMENT | mySTC_FOLD_COMPACT | mySTC_FOLD_PREPROC},
    // Python
    {_T("Python"),
     _T("*.py;*.pyw"),
     wxSTC_LEX_PYTHON,
     {{mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_COMMENT_LINE, NULL},
      {mySTC_TYPE_NUMBER, NULL},
      {mySTC_TYPE_STRING, NULL},
      {mySTC_TYPE_CHARACTER, NULL},
      {mySTC_TYPE_WORD1, PythonWordlist1}, // KEYWORDS
      {mySTC_TYPE_DEFAULT, NULL}, // TRIPLE
      {mySTC_TYPE_DEFAULT, NULL}, // TRIPLEDOUBLE
      {mySTC_TYPE_DEFAULT, NULL}, // CLASSNAME
      {mySTC_TYPE_DEFAULT, PythonWordlist2}, // DEFNAME
      {mySTC_TYPE_OPERATOR, NULL},
      {mySTC_TYPE_IDENTIFIER, NULL},
      {mySTC_TYPE_DEFAULT, NULL}, // COMMENT_BLOCK
      {mySTC_TYPE_STRING_EOL, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL}},
     mySTC_FOLD_COMMENTPY | mySTC_FOLD_QUOTESPY},
    // * (any)
    {(wxChar *)DEFAULT_LANGUAGE,
     _T("*.*"),
     wxSTC_LEX_PROPERTIES,
     {{mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_DEFAULT, NULL},
      {mySTC_TYPE_DEFAULT, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL},
      {-1, NULL}},
     0},
    };

const int g_LanguagePrefsSize = WXSIZEOF(g_LanguagePrefs);

#ifdef WIN32
const int g_StyleSize=10;
#else
const int g_StyleSize=14;
#endif
//----------------------------------------------------------------------------
//! style types
const StyleInfo g_StylePrefs [] = {
    // mySTC_TYPE_DEFAULT
    {_T("Default"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD1
    {_T("Keyword1"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_WORD2
    {_T("Keyword2"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD3
    {_T("Keyword3"),
     _T("PURPLE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD4
    {_T("Keyword4"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD5
    {_T("Keyword5"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD6
    {_T("Keyword6"),
     _T("FIREBRICK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT
    {_T("Comment"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT_DOC
    {_T("Comment (Doc)"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT_LINE
    {_T("Comment line"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT_SPECIAL
    {_T("Special comment"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_ITALIC, 0},

    // mySTC_TYPE_CHARACTER
    {_T("Character"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_CHARACTER_EOL
    {_T("Character (EOL)"),
     _T("KHAKI"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_STRING
    {_T("String"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_STRING_EOL
    {_T("String (EOL)"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_DELIMITER
    {_T("Delimiter"),
     _T("ORANGE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_PUNCTUATION
    {_T("Punctuation"),
     _T("ORANGE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_OPERATOR
    {_T("Operator"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_BRACE
    {_T("Label"),
     _T("VIOLET"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMAND
    {_T("Command"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_IDENTIFIER
    {_T("Identifier"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_LABEL
    {_T("Label"),
     _T("VIOLET"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_NUMBER
    {_T("Number"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_PARAMETER
    {_T("Parameter"),
     _T("VIOLET"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_ITALIC, 0},

    // mySTC_TYPE_REGEX
    {_T("TO or Regular expression"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_UUID
    {_T("END or UUID"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_VALUE
    {_T("Value"),
     _T("ORCHID"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_ITALIC, 0},

    // mySTC_TYPE_PREPROCESSOR
    {_T("Preprocessor"),
     _T("GREY"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_SCRIPT
    {_T("Script"),
     _T("DARK GREY"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_ERROR
    {_T("Error"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_UNDEFINED
    {_T("Undefined"),
     _T("ORANGE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0}

    };

const int g_StylePrefsSize = WXSIZEOF(g_StylePrefs);
