#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Float_included
	#include "Float.h"
#endif

#ifndef Complex_included
	#include "Complex.h"
#endif

#include <setjmp.h>

#define c_in	(*File::CIn)
#define c_out	(*File::COut)
#define reader	(*File::Reader)
#define writer	(*File::Writer)
#define loader	(*File::Loader)
#define dribbler	(*File::Dribbler)
#define stringbuffer	(*File::Stringbuffer)
#define endL	'\n'

class TextControl;
class MAPM;

class File: public Node
{
	FileP _tail;
	StringP _name, _mode;
	FILEP _file;
	int _pos;

	public:
		static bool interactive, backslashes;
		static char digits, precision;
		static charP 
			stringptr,  stringstart,  stringend, 
			rstringptr, rstringstart, rstringend;

		static int stringlen, rstringlen,  indent,  
			marginX, marginY, 
			toPending, inputBlocking;

		static jmp_buf inputBlockingBuffer;

		static StringP line, currentLine, deependProcName;
		static FileP list, Null, Stdin, Stdout,
				CIn, COut, Reader, Writer, 
				Loader, Dribbler, Stringbuffer, TextCtrl;

		static const FILEP textcontrol;
		static TextControlNodeP textControl;

		static const File aFile;
		operator_new;

		   FileP tail() {return _tail;}
		 StringP name() {return _name;}
		 StringP mode() {return _mode;}
		   FILEP file() {return _file;}
		operator bool() {return _file != 0;}

		void settail(FileP   nd) {_tail=nd; check_oldyoung(nd);}
		void setname(StringP nd) {_name=nd; check_oldyoung(NodeP(nd));}
		void setmode(StringP nd) {_mode=nd; check_oldyoung(NodeP(nd));}
		void setfile(FILEP file_) {_file=file_;}

		File(): Node(FILE_), _tail(0), _name(0), _mode(0), 
			_file(0) {}

		File(FILEP file_, StringP name_): 
			Node(FILE_), _tail(0), _mode(0), _file(file_)
		{	setname(name_);
		}
		File(FILEP file_, StringP name_, StringP mode_, FileP tail_): 
			Node(FILE_), _file(file_)
		{	setname(name_); setmode(mode_); settail(tail_);
		}
		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		void setPtrs();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string() {return name();}
		StringP _typeof();
		FileP findInFilelist(bool remove);

		char read_getc();
		int eof(), getc_(), ungetc(int c), putc_(int c),
			pos(), seek(int pos), close();
		size_t read(void *buffer, size_t size, size_t count);
		StringP read(charP prompt);

		static bool checkBreak(), kbhit(), exists(const char *filename);
		static char getch();
		static int getchExt();
		static void
			init(),
			charmodeOn(), charmodeOff(),
			print(FILEP strm, char ch), 
			printIndents(FILEP strm),
			printBin(FILEP strm, char i),
			print(FILEP strm, unsigned char i),
			printBin(FILEP strm, unsigned char i),
			print(FILEP strm, short i),
			printBin(FILEP strm, short i),
			print(FILEP strm, int i),
			printBin(FILEP strm, int i),
			printHex(FILEP strm, int i),
			print(FILEP strm, double d),
			printBin(FILEP strm, double d),
			print(FILEP strm, MAPM d),
			printBin(FILEP strm, MAPM d),
			print(FILEP strm, complexd c),
			printBin(FILEP strm, complexd c),
			print(FILEP strm, ArrayP array, int depth, int width),
			printBin(FILEP strm, ArrayP array),
			print(FILEP strm, IntArrayP array, int width),
			printBin(FILEP strm, IntArrayP array),
			print(FILEP strm, Int16ArrayP array, int width),
			printBin(FILEP strm, Int16ArrayP array),
			print(FILEP strm, FloatArrayP array, int width),
			printBin(FILEP strm, FloatArrayP array),
			print(FILEP strm, PairP ndlist, int depth, int width),
			printBin(FILEP strm, PairP ndlist),
			print(FILEP strm, TableP table, int depth, int width),
			printBin(FILEP strm, TableP table),
			print(FILEP strm, StructP struct_, int depth, int width),
			printBin(FILEP strm, StructP struct_),
			print(FILEP strm, NodeP nd, int depth, int width),
			printBin(FILEP strm, NodeP nd),
			print(FILEP strm, NodeP nd),    
			printHelper(FILEP strm, NodeP nd),
			printNoBracket(FILEP strm, NodeP nd),
			print(FILEP strm, PairPP arg),
			printStack(PairPP arg, bool space),
			printStackBin(PairPP arg),
			_cdecl print(FILEP strm, const char* fmt, ...),
			printPrompt(charP str),
			unblockInput();

		File
			&operator<<(const   char c),
			&operator<<(const    int i),
			&operator<<(const double d),
			&operator<<(const  NodeP n),
			&operator<<(const  LineP l),
			&operator<<(const QuoteP q),
			&operator<<(const PairPP p),
			&operator<<(const  char* s),
			&operator<<(const   VarP v);
};

#define File_included
