//___________________________________________________________________
//
//                         FloatControl Header
//___________________________________________________________________


extern Function 
	lFloatControl, lFloatControlDestroy,
	lFloatControlValue, lFloatControlSetValue, 
	lFloatControlSetRange, lFloatControlOnChange,
	lFloatControlEnable;

class wxStaticText;

class FloatControl: public wxSpinCtrlDbl
{
	public:
		PairP onChange;
		int format;
		FloatControlNodeP floatControlNode;

		FloatControl(FloatControlNodeP floatControlNode_, int style);
		FloatControl(FloatControlNodeP floatControlNode_,
			wxWindow* parent, wxWindowID id, 
			double value, double minValue, double maxValue, double increment,
			int digits = -1, int format_ = lg_fmt,
			PairP onScroll_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxSP_ARROW_KEYS, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "FloatControl");
		~FloatControl();

		void 
			OnClose(wxCloseEvent &event),
			OnChange(wxSpinEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef FloatControl *FloatControlP;

class FloatControlNode: public Node
{
	public:
		FloatControlP floatControl;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;
		int style;

		static const FloatControlNode aFloatControlNode;

		operator_new;
		PairP onChange();
		void setonChange(NodeP function);

		FloatControlNode();
		FloatControlNode(FrameNodeP parentFrame_, GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
