//___________________________________________________________________
//
//                         Frame Header
//___________________________________________________________________

extern Function lFrame, lFrameDestroy, 
	lFrameOnChar, lFrameOnKeyDown, lFrameOnKeyUp,
	lFrameSetFocus, lFrameEnable,
	lFrameMaximize, lFrameIconize, lFrameFullScreen,
	lFrameSetClientSize, 
	lFrameSetColor, lFrameSetBackgroundColor,
	lFrameSetFontSize, lFrameSetFontName,
	lFrameSetFontStyle, lFrameSetFontWeight,
	lFrameSetShape, lFrameSetSizer;

class Frame: public wxFrame
{
	public:
		PairP 
			onChar, onKeyUp, onKeyDown, shape;
		BoxSizerNodeP boxSizer;
		FrameNodeP frameNode;
		wxString title;

		Frame(FrameNodeP frameNode_);
		Frame(FrameNodeP frameNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString& title, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxDEFAULT_FRAME_STYLE, 
			const wxString& name = "Frame");
		~Frame();

		void 
			OnClose(wxCloseEvent &event),
			OnChar(wxKeyEvent &event),
			OnKeyDown(wxKeyEvent &event),
			OnKeyUp(wxKeyEvent &event);

		bool setShape(PairP shape_);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef Frame *FrameP;

class FrameNode: public Node
{
	public:
		FrameP frame;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;
		WindowPairP children;

		static const FrameNode aFrameNode;

		operator_new;
		PairP onChar(), onKeyDown(), onKeyUp(), shape();
		BoxSizerNodeP boxSizer();
		void 
			setonChar	(NodeP function), 
			setonKeyDown(NodeP function),
			setonKeyUp	(NodeP function),
			setshape		(PairP shape_),
			realsetshape(PairP shape_),
			setSizer(BoxSizerNodeP boxSizer_);

		FrameNode();
		FrameNode(
			FrameNodeP parentFrame_,
			GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void aftersetPtrs();
		void recreate();
		void aftersetPtrs3();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
