//___________________________________________________________________
//
//                         Init Header
//___________________________________________________________________

#define Throw_Nodes(x)							\
	x(Error) x(Pause) x(Toplevel) x(System)

#define Unary_Arithmetics(x)										\
	x(BitNot_) x(Random_)											\
	x(Int_) x(Int16_) x(Int8_) x(UInt8_) x(Float_)			\
	x(BigFloat_)														\
	x(Int) x(Int16) x(Int8) x(UInt8) x(Float)	x(Complex_)	\
	x(BigFloat)															\
	x(IntPtr) x(Int16Ptr) x(Int8Ptr) x(UInt8Ptr) x(FloatPtr)	\
	x(Bool)																\
	x(Truncate_) x(Round_)											\
	x(Sin_) x(Cos_) x(Tan_)											\
	x(ArcSin_) x(ArcCos_)											\
	x(radSin_) x(radCos_) x(radTan_)								\
	x(radArcSin_) x(radArcCos_)									\
	x(Abs_) x(Sqr_) x(Sqrt_) x(Exp_) x(LN_) x(Log10_)		\
	x(Real_) x(Imag_) x(Conjugate_) x(Signum_)

#define Binary_Arithmetics(x)					\
	x(Remainder_) x(AShift_) x(LShift_)		\
	x(BitOr_) x(BitAnd_) x(BitXOr_)			\
	x(Power_) x(ArcTan_) x(RadArcTan_)		\
	x(SaturateAbove) x(SaturateBelow)

#define Special_Vars(x)										\
	x(Startup) x(ErrorAction)								\
	x(RedefP) x(LoadNoisily)								\
	x(True) x(False)											\
	x(IntMax) x(Int16Max) x(Int8Max) x(UInt8Max)		\
	x(FloatMax) x(Pi) x(BigFloatPi)						\
	x(PrintDepthLimit) x(PrintWidthLimit)				\
	x(Determinant) x(Template_Lists)

#define Eval_Macros(x)													\
	x(To) x(End) x(_Macro_) x(If) x(IfElse)						\
	x(Output) x(Op) x(Stop) x(Goto) x(For) x(Foreach)			\
	x(Tag) x(List) x(_SetItem) x(mdSetItem)

#define Permanent_Objects(x)		\
	x(ListEnd)							\
	  Throw_Nodes(x)					\
	  Unary_Arithmetics(x)			\
	 Binary_Arithmetics(x)			\
	Special_Vars(x)					\
	 Eval_Macros(x)

#define Number_Constants(x)		\
	x(Zero) x(One) x(Minus_One)

#define Infix_Arithmetics(x)							\
	x(Plus_Sign) x(Minus_Sign) x(Minus_Tight)		\
	x(Mul_Sign) x(Div_Sign) x(Mod_Sign)
 
#define Special_Symbols(x)														\
	x(Left_Paren) x(Right_Paren) x(Query) x(Dot) x(SingleQuote)		\
	x(IntArray_) x(Int16Array_) x(FloatArray_)				\
	x(Else) x(Word_) x(Void) x(Null_Word)

#define Permanent_Objects2(x)		\
	 Number_Constants(x)				\
	  Infix_Arithmetics(x)			\
	Special_Symbols(x)

#define Node_Type_Strings(x,y)	\
	x( Node ) y("Node") \
	x( Int  ) y("Int") \
	x( Int16) y("Int16") \
	x( Int8 ) y("Int8") \
	x(UInt8 ) y("UInt8") \
	x( Float) y("Float") \
	x( BigFloat) y("BigFloat") \
	x(Complexd) y("Complex") \
	x(Primitive) y("Primitive") \
	x( Array) y("Array") \
	x(IntArray) y("IntArray") \
	x(Int16Array) y("Int16Array") \
	x(FloatArray) y("FloatArray") \
	x(String) y("Word") \
	x(Bitmap) y("Bitmap") \
	x(Texture) y("Texture") \
	x(TurtleNode) y("Turtle") \
	x(Pair) y("List") \
	x(Line) y("Line") \
	x(Runparsed) y("Runparsed") \
	x(Tree) y("Tree") \
	x(Quote) y("Quote") \
	x(Colon) y("Colon") \
	x(WindowPair) y("WindowPair") \
	x(Procedure) y("Procedure") \
	x(File) y("File") \
	x(Table) y("Table") \
	x(Struct) y("Struct") \
	x(GraphicNode) y("Graphic") \
	x(DynamicLibrary) y("DynamicLibrary") \
	x(SliderNode) y("Slider") \
	x(FrameNode) y("Frame") \
	x(GraphNode) y("Graph") \
	x(ButtonNode) y("Button") \
	x(ToggleButtonNode) y("ToggleButton") \
	x(CheckBoxNode) y("CheckBox") \
	x(RadioButtonNode) y("RadioButton") \
	x(GaugeNode) y("Gauge") \
	x(IntControlNode) y("IntControl") \
	x(FloatControlNode) y("FloatControl") \
	x(StaticTextNode) y("StaticText") \
	x(TextControlNode) y("TextControl") \
	x(ListBoxNode) y("ListBox") \
	x(ChoiceBoxNode) y("ChoiceBox") \
	x(ComboBoxNode) y("ComboBox") \
	x(BoxSizerNode) y("BoxSizer") \
	x(ListControlNode) y("ListControl") \


#define declare_Object(x)	_##x,
#define declare_Object2(x)	type_##x,
#define UNUSED(y)

extern ObjectP 
	Permanent_Objects (declare_Object) 
	Permanent_Objects2(declare_Object)
	Node_Type_Strings (declare_Object2, UNUSED) _;

extern PairP _Not_Enough_node;

extern void init(void);
