#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Int16Array_included

class Int16Array: public Node // is an int array with a length and an origin.
{
	int _length, _origin;
	shortP _data;

	public:
		static const Int16Array aInt16Array;

		operator_new;
		Int16Array(): Node(INT16ARRAY), _length(0), _origin(0), _data(0) {}
		Int16Array(int length_, int origin_=1);
		Int16Array(Int16ArrayP array_);
		void free();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string();

		OPERATORS_DECL
		int compare(NodeP nd);
		int count();
		int _sizeof();
		StringP _typeof();
		bool equalP(NodeP b);
		NodeP first_();
		NodeP butFirst();
		NodeP last();
		NodeP butLast();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP resize(int newsize);
		NodeP lowPassFilter(double weight);
		NodeP saturateAbove(double limit);
		NodeP saturateBelow(double limit);
		NodeP item(int index);
		NodeP item(NodeP index, NodeP result);
		NodeP items(NodeP start, NodeP end);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp, bool substr);
		NodeP setitems(NodeP start, NodeP newitems);
		NodeP reverse();
		NodeP rotate(int places);
		NodeP shuffle();
		PairP list();
		ArrayP array(int origin=1);
		IntArrayP intarray(int origin=1);
		Int16ArrayP int16array(int origin=1);
		FloatArrayP floatarray(int origin=1);
		NodeP readbin(FileP file);

		 int length() {return _length;}
		 int origin() {return _origin;}
		shortP data() {return _data;}
		void setorigin(int origin_) {_origin=origin_;}
};

	#define Int16Array_included
#endif
