//___________________________________________________________________
//
//                        Class MainFrame
//___________________________________________________________________

extern Function 
	lTextScreen, lsplitScreen, lfullScreen, 
	lsetVarsSplitter, lsetCallsSplitter,
	lallFullScreen, lnotFullScreen;

enum
{	ID_CONSOLE_OPEN,
	ID_CONSOLE_SAVE,
	ID_CONSOLE_AUTOSAVE,

	ID_PICTURE_OPEN,
	ID_PICTURE_SAVE,
	ID_PICTURE_TEXT_OPEN,
	ID_PICTURE_TEXT_SAVE,
	ID_PICTURE_AUTOSAVE,

	ID_NODES_OPEN,
	ID_NODES_SAVE,
	ID_NODES_AUTOSAVE,

	ID_PAGE_SETUP,
	ID_EDIT_REPEAT,
	ID_EDIT_RESET,

	ID_VIEW_GRAPH,
	ID_VIEW_VARS,
	ID_VIEW_CALLS,
	ID_VIEW_MEMORY,

	ID_WINDOW_SPLIT,
	
	ID_OPEN_FILE_AT_CURSOR,

	ID_CONSOLE_INSERT_MENU,
	ID_CONSOLE_INSERT,
	ID_CONSOLE_INSERT_MAX=ID_CONSOLE_INSERT+1000,
};

class Graph;
class Vars;
class Calls;
class Splitter;
class wxPrintData;
class wxPageSetupData;

class MainFrame: public wxFrame
{
	public:
		bool initialized, inGraphicsMode, inSplitScreen, 
			graphAutosave, nodesAutosave;
		Graph *graph;
		GraphNodeP graphNode;
		Console *console;
		Vars *vars;
		Calls *calls;
		Splitter *splitter, *splitter2, *splitter3;
		wxMenu *fileMenu, *editMenu, *viewMenu, *helpMenu;
		wxMenuBar *menuBar;

		MainFrame(wxWindow* parent, wxWindowID id, 
			const wxString& title, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxDEFAULT_FRAME_STYLE, 
			const wxString& name = "frame",
			bool consoleAutosave = true, int caretpos = 0,
			bool pictureAutosave = true,
			bool nodesAutosave_ = true);

		~MainFrame();

		int getHeight(), getHeight2();
		double getSplitterRatio();
		void setSplitter(double y), 
			fullScreen(), splitScreen(), TextScreen(),
			allFullScreen(), notFullScreen(),
			printPrompt(charP str),
			OnViewMemory		(wxCommandEvent &event);

	protected:
		wxPrintData *printData;
		wxPageSetupData *pageSetupData;

		void 
			OnClose				(wxCloseEvent   &event),
			OnExit				(wxCommandEvent &event),
			OnMove				(wxMoveEvent    &event),
			OnErase				(wxEraseEvent   &event),
			OnAppAbout			(wxCommandEvent &event), 
			OnFileNew			(wxCommandEvent &event), 
			OnFileOpen			(wxCommandEvent &event),
			OnFileSave			(wxCommandEvent &event),
			OnConsoleOpen		(wxCommandEvent &event),
			OnConsoleSave		(wxCommandEvent &event),
			OnConsoleAutoSave	(wxCommandEvent &event),
			OnPictureOpen		(wxCommandEvent &event),
			OnPictureSave		(wxCommandEvent &event),
			OnPictureTextOpen	(wxCommandEvent &event),
			OnPictureTextSave	(wxCommandEvent &event),
			OnPictureAutoSave	(wxCommandEvent &event),
			OnNodesOpen			(wxCommandEvent &event),
			OnNodesSave			(wxCommandEvent &event),
			OnNodesAutoSave	(wxCommandEvent &event),
			OnEditRepeat		(wxCommandEvent &event),
			OnEditReset			(wxCommandEvent &event),
			OnViewGraph			(wxCommandEvent &event), 
			OnViewVars			(wxCommandEvent &event), 
			OnViewCalls			(wxCommandEvent &event),
			OnHelp				(wxCommandEvent &event),

			OnPrint				(wxCommandEvent& event),
			OnPrintPreview		(wxCommandEvent& event),
			OnPrintSetup		(wxCommandEvent& event),
			OnPageSetup			(wxCommandEvent& event);
		DECLARE_EVENT_TABLE()
};
