//___________________________________________________________________
//
//                         RadioButton Header
//___________________________________________________________________


extern Function 
	lRadioButton, lRadioButtonDestroy, lRadioButtonOnClick,
	lRadioButtonValue, lRadioButtonSet,
	lRadioButtonEnable;

class RadioButton: public wxRadioButton
{
	public:
		PairP onClick;
		RadioButtonNodeP radioButtonNode;

		RadioButton(RadioButtonNodeP radioButtonNode_);
		RadioButton(RadioButtonNodeP radioButtonNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label,
			PairP onClick_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "RadioButton");
		~RadioButton();

		void 
			OnClose(wxCloseEvent &event),
			OnClick(wxCommandEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef RadioButton *RadioButtonP;

class RadioButtonNode: public Node
{
	public:
		RadioButtonP radioButton;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;

		static const RadioButtonNode aRadioButtonNode;

		operator_new;
		PairP onClick();
		void setonClick(NodeP function);

		RadioButtonNode();
		RadioButtonNode(
			FrameNodeP parentFrame_,
			GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
