//___________________________________________________________________
//
//										Shadow.h
//___________________________________________________________________

// plane equation
struct sPlaneEq{
	double a, b, c, d;
};

// structure describing an object's face
struct sPlane{
	unsigned int p[3];
	Point normals[3];
	unsigned int neigh[3];
	sPlaneEq PlaneEq;
	bool visible;
};

class ShadowObject
{
public:
	int nPoints, nPlanes, ptsize, plsize, dptsize, dplsize;
	Point *points, *texs;
	Color *colors;
	sPlane *planes;

	ShadowObject(): nPoints(0), nPlanes(0), 
		ptsize(0), plsize(0), 
		dptsize(256), dplsize(256), 
		points(0), colors(0), texs(0), planes(0) 
	{
		checkPoints(1);
		nPoints=1;
	}

	~ShadowObject();

	void checkPoints(int i);
	void checkPlanes(int i);
	void clear();

	int read(char *st);

	void setConnectivity();
	void calcPlane(sPlane *plane);
	void draw();

	void castShadows(Point lp, double ldir);
};
