//___________________________________________________________________
//
//                         Slider Header
//___________________________________________________________________


extern Function 
	lSlider, lSliderDestroy,
	lSliderValue, lSliderSetValue, lSliderSetRange, lSliderOnScroll,
	lSliderEnable;

class wxStaticText;

class Slider: public wxSlider
{
	public:
		PairP onScroll;
		wxStaticText *label;
		SliderNodeP sliderNode;

		Slider(SliderNodeP sliderNode_, int style);
		Slider(SliderNodeP sliderNode_,
			wxWindow* parent, wxWindowID id, 
			int value , int minValue, int maxValue, 
			PairP onScroll_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxSL_HORIZONTAL, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "Slider");
		~Slider();

		void 
			OnClose(wxCloseEvent &event),
			OnScroll(wxScrollEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		static int defaultStyle;

		DECLARE_EVENT_TABLE()
};
typedef Slider *SliderP;

class SliderNode: public Node
{
	public:
		SliderP slider;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;
		int style;

		static const SliderNode aSliderNode;

		operator_new;
		PairP onScroll();
		void setonScroll(NodeP function);

		SliderNode();
		SliderNode(FrameNodeP parentFrame_, GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
