//___________________________________________________________________
//
//                         StaticText Header
//___________________________________________________________________

extern Function 
	lStaticText, lStaticTextDestroy, 
	lStaticTextLabel, lStaticTextSetLabel,
	lStaticTextSetBackgroundColor, lStaticTextSetColor,
	lStaticTextSetFontSize, lStaticTextSetFontName,
	lStaticTextSetFontStyle, lStaticTextSetFontWeight;

class StaticText: public wxStaticText
{
	public:
		StaticTextNodeP staticTextNode;

		StaticText(StaticTextNodeP staticTextNode_);
		StaticText(StaticTextNodeP staticTextNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxString& name = "StaticText");
		~StaticText();

		void 
			OnClose(wxCloseEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};
typedef StaticText *StaticTextP;

class StaticTextNode: public Node
{
	public:
		StaticTextP staticText;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;

		static const StaticTextNode aStaticTextNode;

		operator_new;

		StaticTextNode();
		StaticTextNode(
			FrameNodeP parentFrame_, 
			GraphNodeP parentGraph_);

		void free();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
