#ifndef Node_included
	#include "Node.h"
#endif

class Backslash
{	public:
		char size, begin;
		charP chars;
		char array[0x100], 
		   unarray[0x100];
		bool   _is[0x100];

		Backslash();
		bool     is(char c) {return     _is[(unsigned char)(c)];}
		char encode(char c) {return   array[(unsigned char)(c)];}
		char decode(char c) {return unarray[(unsigned char)(c)];}
};
extern Backslash backslash;

class wxString;

class String: public Node
{
	public:
		struct Head
		{	unsigned int refCount;
			char str[1];	    // This array will be of variable length really
		};
		typedef Head* HeadP;

	private:
		int _length;
		charP _ptr;
		HeadP _head;

	public:
		static const int digits;	// max number of digits in a number
		static bool caseIgnored;
		static const String aString;

		typedef charP     CopyRoutine(charP s1,  charP s2, int n);
		typedef charP PairCopyRoutine(charP s1, PairPP s2, int n);
		typedef  int   CompareRoutine(charP s1,  charP s2, int n);

		operator_new;
		String():             Node(STRING), _length(0), _ptr(0), _head(0) {}
		String(int length);
		String(StringP sp);
		String(StringP sp, StringP sp2);
		String(NodeType typ): Node(typ),    _length(0), _ptr(0), _head(0) {}
		String(charP str);
		String(wxString str);

		String(charP strptr, HeadP strhead, int length, NodeType typ, 
				CopyRoutine &copy_routine);	// use only if not empty; else use newString

		String(PairPP arg, int length, NodeType typ, 
				PairCopyRoutine &copy_routine);	// dito

		static StringP 
			make(charP ptr, HeadP head, int length, NodeType type, CopyRoutine &copy),
			fromList(PairPP arg,        int length, NodeType type, PairCopyRoutine &copy);

		int length() {return _length;}
		charP  ptr() {return _ptr;}
		HeadP head() {return _head;}

		void free();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP   string() {return this;}
		   int   numberP(); 
		double getnumber(); 
		NodeP     number();

		OPERATORS_DECL
		int compare(NodeP nd);
		double _max(double d), _min(double d);
		NodeP Norm(), maxNorm();

		int count();
		int _sizeof();
		StringP _typeof();

		StringP first();
		NodeP first_();
		NodeP butFirst();
		NodeP last();
		NodeP butLast();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);

		NodeP item(int index);
		NodeP item(NodeP index, NodeP result);
		NodeP bititem(NodeP index);
		NodeP memberP(NodeP subobj, bool notp, bool substr);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		void removeitem(NodeP index);
		NodeP reverse();
		NodeP remove(NodeP thing);
		NodeP remdup();


		void setXYZ(NodeP ynode, NodeP znode);

		FileP findInFilelist(bool remove);

		FILEP open_file(charP access);

		NodeP upper();
		NodeP lower();

		PairP list();
		ArrayP array(int origin);
		NodeP readbin(FileP file);

		StringP noparity_lower(), unspace();
		charP expand_slash();

		PairP runparse_node(PairPP ndsptr, 
			bool &was_assignment, bool &was_dot);
		PairP parser(bool semi);

		static bool is_digit(char ch) {return '0' <= ch && ch <= '9';}
		static charP addSeparator(const char *path);
		static charP convertQMtoP(charP ptr, int len);
		static CopyRoutine 
			copy,
			copy_quote,
			copy_colon,
			copy_noparity,
			copy_cap,
			copy_low,
			copy_unspace,
			copy_noformat,
			copy_noparitylow,
			copy_mend,
			copy_mend_nosemi,
			copy_reverse;

		static PairCopyRoutine
			copy_word;

		static CompareRoutine 
			comp_noparity,
			comp_case,
			comp_low,
			comp_noparitylow;
};

#define String_included
