//___________________________________________________________________
//
//                         ToggleButton Header
//___________________________________________________________________


extern Function 
	lToggleButton, lToggleButtonDestroy, lToggleButtonOnClick,
	lToggleButtonValue, lToggleButtonSetValue,
	lToggleButtonEnable;

#ifdef WIN32
class ToggleButton: public wxToggleButton
#else
class ToggleButton: public wxCheckBox
#endif
{
	public:
		PairP onClick;
		ToggleButtonNodeP toggleButtonNode;

		ToggleButton(ToggleButtonNodeP buttonNode_);
		ToggleButton(ToggleButtonNodeP buttonNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label,
			PairP onClick_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "ToggleButton");
		~ToggleButton();

		void 
			OnClose(wxCloseEvent &event),
			OnClick(wxCommandEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef ToggleButton *ToggleButtonP;

class ToggleButtonNode: public Node
{
	public:
		ToggleButtonP toggleButton;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;

		static const ToggleButtonNode aToggleButtonNode;

		operator_new;
		PairP onClick();
		void setonClick(NodeP function);

		ToggleButtonNode();
		ToggleButtonNode(
			FrameNodeP parentFrame_,
			GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
