#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/app.h>
#include <wx/listctrl.h>

#include "Main.h"
#include "File.h"
#include "Pair.h"
#include "Object.h"
#include "Table.h"
#include "String.h"

#include "Eval.h"
#include "Stack.h"
#include "Vars.h"
#include "LogoApp.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

bool updateVarsOnStep=true;

Vars::Vars(wxWindow* parent, wxWindowID id, 
			  const wxPoint& pos, 
			  const wxSize& size, 
			  long style, 
			  const wxValidator& validator, 
			  const wxString& name):
wxListCtrl(parent, id, pos, size, style, validator, name)
{
	inupdate=false;
	InsertColumn(0,  "Name", wxLIST_FORMAT_RIGHT, 100);
	InsertColumn(1, "Value", wxLIST_FORMAT_LEFT , 500);

	theApp->vars=this;
	return;
}

wxString Vars::OnGetItemText(long item, long column) const
{
	if (!column)
		return namearr[item];
	return valarr[item];
}

void Vars::update()
{
	if (inupdate)
		return;

	inupdate=true;

	charP reserve=new char[100000];
	if (!reserve)
		return;
	delete reserve;

	PairP namesStart=root->contents(VALS, NORMAL_OBJECT),
		names=namesStart;

	if (names)
		count=names->count();
	else
		count=0;
	int stacksize=Evaluator::varStack.index-Evaluator::varStack.base;
	if (stacksize)
		stacksize++;
	count+=stacksize;
	int y=stacksize;

	namearr.Clear(); namearr.Alloc(count); namearr.Add(wxEmptyString, count);
	 valarr.Clear();  valarr.Alloc(count);  valarr.Add(wxEmptyString, count);

	while (names)
	{
		StringP name=StringP(names->first());
		ObjectP obj=name->intern();
		if (obj)
		{	
if (y >= count)
{	c_out << "Vars::update error " << count << namesStart << endL;
	break;
}
			NodeP var=obj->var();
			StringP shortname=new String(obj->name());
		
			namearr[y]=shortname->ptr();
			if (var)
			{	StringP varstr=var->string();
				if (varstr  &&  varstr->is.string)
				{	StringP shortvar=new String(
						varstr->ptr(), 0, varstr->length(), STRING, 
						String::copy_noformat);
					if (shortvar->ptr())
						valarr[y]=shortvar->ptr();
				}
			}
			y++;
		}
		next(names);
	}
	y=0;
	VarP base=Evaluator::varStack.base;
	for (VarP i=Evaluator::varStack.index;  i>base;  i--)
	{	StringP name=i->object->name();
		namearr[y]=name->ptr();
		StringP val=0;
		if (i->val)
		{	StringP valstr;
			valstr=i->val->string();
			if (valstr  &&  valstr->is.string)
			{	StringP shortval=new String(
					valstr->ptr(), 0, valstr->length(), STRING, 
					String::copy_noformat);
				if (shortval->ptr())
					valarr[y]=shortval->ptr();
			}
		}else
			valarr[y]=wxEmptyString;
		y++;
	}
	if (stacksize)
	{	namearr[y]=wxEmptyString;
		valarr[y]=wxEmptyString;
	}
	SetItemCount(count);
	if (count >= 1)
		RefreshItems(0, count-1);

	inupdate=false;
}
/*
void Vars::update()
{
	int y=0;
	PairP names=root->contents(VALS, NORMAL_OBJECT);

	DeleteAllItems();
	while (names)
	{
		StringP name=StringP(names->first());
		ObjectP obj=root->find(name);
		if (obj)
		{	NodeP var=obj->var();
			StringP shortname=new String(name);
		
			InsertItem(y, shortname->ptr());
			if (var)
			{	StringP varstr=var->string();
				StringP shortvar=new String(
					varstr->ptr(), 0, varstr->length(), STRING, 
					String::copy_noformat);
				SetItem(y, 1, shortvar->ptr());
			}
			y++;
		}
		next(names);
	}
}
*/

NodeP lupdateVars(PairPP)
{
	if (theApp->vars) 
		theApp->vars->update();
	return Unbound;
}

NodeP lupdateVarsOnStep(PairPP arg)
{
	int update=arg[1]->a_bool(1);
	if (!throwing)
		updateVarsOnStep=(update==1);
	return Unbound;
}
