//___________________________________________________________________
//
//                         Window Header
//___________________________________________________________________

class Window: public wxWindow
{
	public:
		PairP 
			onChar, onKeyUp, onKeyDown,
			onMouseLeftDown  , onMouseRightDown  , onMouseMiddleDown  ,
			onMouseLeftUp    , onMouseRightUp    , onMouseMiddleUp    ,
			onMouseLeftDClick, onMouseRightDClick, onMouseMiddleDClick,
			onMouseMotion;

		Window();
		Window(wxWindow* parent, wxWindowID id, 
			const wxString& title, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxString& name = wxPanelNameStr);

		virtual void 
			OnChar(wxKeyEvent &event),
			OnKeyDown(wxKeyEvent &event),
			OnKeyUp(wxKeyEvent &event),
			OnMouseLeftDown(wxMouseEvent &event),
			OnMouseRightDown(wxMouseEvent &event),
			OnMouseMiddleDown(wxMouseEvent &event),
			OnMouseLeftUp(wxMouseEvent &event),
			OnMouseRightUp(wxMouseEvent &event),
			OnMouseMiddleUp(wxMouseEvent &event),
			OnMouseLeftDClick(wxMouseEvent &event),
			OnMouseRightDClick(wxMouseEvent &event),
			OnMouseMiddleDClick(wxMouseEvent &event),
			OnMouseMotion(wxMouseEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef Window *WindowP;

class WindowNode: public Node
{
	public:
		WindowP Window;

		static const WindowNode aWindowNode;

		operator_new;
		PairP 
			onChar(), onKeyDown(), onKeyUp(),
			onMouseLeftDown()  , onMouseRightDown()  , onMouseMiddleDown()  ,
			onMouseLeftUp()    , onMouseRightUp()    , onMouseMiddleUp()    ,
			onMouseLeftDClick(), onMouseRightDClick(), onMouseMiddleDClick(),
			onMouseMotion();
		void 
			setonChar				 (NodeP function), 
			setonKeyDown			 (NodeP function),
			setonKeyUp				 (NodeP function),
			setonMouseLeftDown    (NodeP function),
			setonMouseRightDown   (NodeP function),
			setonMouseMiddleDown  (NodeP function),
			setonMouseLeftUp      (NodeP function),
			setonMouseRightUp     (NodeP function),
			setonMouseMiddleUp    (NodeP function),
			setonMouseLeftDClick	 (NodeP function),
			setonMouseRightDClick (NodeP function),
			setonMouseMiddleDClick(NodeP function),
			setonMouseMotion		 (NodeP function);

		WindowNode();
		WindowNode(WindowP Window_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		void setPtrs();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string();
		wxString wxstring();
		StringP _typeof();

};

extern Function lWindow, lWindowDestroy;
